'use strict'
const trim = require('lodash.trim')
const isObj = require('lodash.isplainobject')
const monkey = require('ast-monkey')

function containsOnlyEmptySpace (input) {
  function isStr (something) { return typeof something === 'string' }
  const isArr = Array.isArray
  let found = true

  if (!isArr(input) && !isObj(input) && !isStr(input)) {
    return false
  } else if (isStr(input)) {
    return trim(input).length === 0
  } else {
    input = monkey.traverse(input, (key, val, innerObj) => {
      let current = (val !== undefined) ? val : key
      if (isStr(current) && (trim(current) !== '')) {
        found = false
      }
      return current
    })
  }
  return found
}

module.exports = containsOnlyEmptySpace
